package estimateur.controleur;

import java.util.*;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import estimateur.gui.*;
import estimateur.gui.estimation.Graphique;
import estimateur.gui.estimation.ResultatFrame;
import estimateur.modele.*;

public class Analyseur {
	
	// Fenetre de l'application
	public static FenetrePrincipale fenetre;
	
	// Sources de financement définies par l'utilisateur
	public static Vector<Financement> sources;
	
	public Analyseur(){
		this.sources = new Vector<Financement>();
	}
	
	/**
	 * Méthode invoquée lorsque l'on doit procéder au calcul de 
	 * la somme des sources de financement.	 *
	 */
	public static void estimer(){
		
		System.out.println("\nCalcul de la somme des sources suivantes : ");
		
		for (Financement f : sources) {
			System.out.println(f);
		}
		
		//Calcul de la somme
		Somme somme = new Somme(sources);
		
		//Affichage du résultat
		Graphique g = new Graphique(somme);
		try {
			JFrame resultat = new ResultatFrame(somme.estimer(true),g);
			System.out.println(somme.estimer(false));
		} catch (ErreurEstimationException e) {
			e.printStackTrace();
		}

	}
	
	public static void main(String[] args) {
		
		Analyseur analyseur = new Analyseur();
		
		//Pas pour calculer les aplpha-coupes
		try {
			double pas = Double.parseDouble(args[0]);
			estimateur.modele.Somme.pas_alpha = pas;
		} catch (Exception e){
			estimateur.modele.Somme.pas_alpha = 0.01d ;
		}

		FenetrePrincipale f = new FenetrePrincipale(analyseur);
		
	}


}
