package estimateur.gui;

import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.io.*;

import javax.swing.*;


public class MenuPrincipal extends JMenuBar {
	
	FenetrePrincipale fenetre;
	
	protected JMenuItem nouveauItem;
	
	protected JMenuItem ouvrirItem;
	
	protected JMenuItem enregistrerItem;
	
	protected JMenuItem ajoutSourceItem;
	
	protected JMenuItem suppressionSourceItem;
	
	protected JMenuItem quitterItem;
	
	public MenuPrincipal(FenetrePrincipale f){
		
		super();
		
		this.fenetre = f;
		
		JMenu menuFichier = new JMenu("File");
		menuFichier.setMnemonic(KeyEvent.VK_F);
		this.add(menuFichier);
		
		JMenu menuAide = new JMenu("Help");
		menuAide.setMnemonic(KeyEvent.VK_H);
		this.add(menuAide);
		
		 nouveauItem = new JMenuItem("New",
                KeyEvent.VK_N);
		nouveauItem.addActionListener(new NouveauListener());
		nouveauItem.setIcon(new ImageIcon(Util.call.imageFromJar("img/file.png")));
		menuFichier.add(nouveauItem);
		
		 ouvrirItem = new JMenuItem("Open...",
                KeyEvent.VK_O);
		ouvrirItem.addActionListener(new OuvrirListener());
		ouvrirItem.setIcon(new ImageIcon(Util.call.imageFromJar("img/open.png")));
		menuFichier.add(ouvrirItem);
		
		 enregistrerItem = new JMenuItem("Save as...",
                KeyEvent.VK_A);
		 enregistrerItem.setEnabled(false);
		enregistrerItem.addActionListener(new EnregistrerListener());
		enregistrerItem.setIcon(new ImageIcon(Util.call.imageFromJar("img/sauver.png")));
		menuFichier.add(enregistrerItem);
		
		menuFichier.addSeparator();
		
		 ajoutSourceItem = new JMenuItem("Add source",
                KeyEvent.VK_S);
		ajoutSourceItem.setIcon(new ImageIcon(Util.call.imageFromJar("img/ajout.png")));
		ajoutSourceItem.addActionListener(new AjouterListener());
		menuFichier.add(ajoutSourceItem);
		
		 suppressionSourceItem = new JMenuItem("Delete source",
                KeyEvent.VK_D);
		suppressionSourceItem.setIcon(new ImageIcon(Util.call.imageFromJar("img/suppression.png")));
		suppressionSourceItem.addActionListener(new SupprimerListener());
		suppressionSourceItem.setEnabled(false);
		menuFichier.add(suppressionSourceItem);
		
		menuFichier.addSeparator();
		
		quitterItem = new JMenuItem("Exit",
                KeyEvent.VK_X);
		quitterItem.addActionListener(new QuitterListener());
		quitterItem.setIcon(new ImageIcon(Util.call.imageFromJar("img/exit.png")));
		menuFichier.add(quitterItem);
		
		JMenuItem aProposItem = new JMenuItem("About",
                KeyEvent.VK_P);
		aProposItem.addActionListener(new AProposListener());
		aProposItem.setIcon(new ImageIcon(Util.call.imageFromJar("img/info.png")));
		menuAide.add(aProposItem);
		
	}
	
	private class NouveauListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			if (fenetre.tabbedPane.getTabCount() > 0){
				Object[] options = {
						"Continue",
						"Cancel"};
				int n = JOptionPane.showOptionDialog(fenetre,
				"Warning: you are going to lose all the sources you have defined. ",
				"New simulation",
				JOptionPane.YES_NO_OPTION,
				JOptionPane.QUESTION_MESSAGE,
				null,
				options,
				options[1]);
				if (n==0){
					fenetre.tabbedPane.removeAll();
					fenetre.tabbedPane.setVisible(false);
					fenetre.texteBienvenue.setVisible(true);
				}
			}
			
		}	
	}
	
	private class OuvrirListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			
			JFileChooser fc = new JFileChooser();	
			int returnVal = fc.showOpenDialog(fenetre);
			// 0 ouvrir ; 1 annuler
			
			if (returnVal == 0) {
				fenetre.tabbedPane.removeAll();
				fenetre.persistance.charger(fc.getSelectedFile().getAbsolutePath());
			}
			
		}	
	}
	
	private class EnregistrerListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			
			JFileChooser fc = new JFileChooser();	
			int returnVal = fc.showSaveDialog(fenetre);
			// 0 enregistrer ; 1 annuler
			
			if (returnVal == 0) {
				if (fc.getSelectedFile().exists()) {
					Object[] options = {
							"Overwrite",
							"Cancel"};
					int n = JOptionPane.showOptionDialog(fenetre,
					"The file already exists! It will be overwritten. ",
					"Warning",
					JOptionPane.YES_NO_OPTION,
					JOptionPane.QUESTION_MESSAGE,
					null,
					options,
					options[1]);
					if (n == 1) return;
				}
				fenetre.persistance.sauver(fc.getSelectedFile().getAbsolutePath());
			}

		}	
	}
	
	private class AjouterListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			fenetre.nouvelleSource();
		}	
	}
	
	private class SupprimerListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			fenetre.supprimerSource();
		}	
	}
	
	private class QuitterListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			System.exit(0);
		}	
	}
	
	private class AProposListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			
			String texte = "<html><div style=\"text-align:center;font:1.2em\">Funding Calculator</div><br/>" +
					"<div style=\"text-align:center;\">October 2008</div><br/>" +
					"Adrian "+"Courrèges".toUpperCase() + 
					", Pierre BAUDEMONT" +
					"<br/><br/></html>";
			
			JOptionPane.showMessageDialog(fenetre, 
					texte,
					"About",
					JOptionPane.INFORMATION_MESSAGE);
			
		}	
	}
	
}
