package estimateur.gui;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Properties;
import java.util.Vector;

import estimateur.gui.financement.SourcePanel;

public class Persistance {
	
	private FenetrePrincipale f;

	public Persistance(FenetrePrincipale f) {
		this.f = f;
	}
	
	public void sauver(String chemin){
		
		PrintWriter writer;
		
		try {
			writer = new PrintWriter (new OutputStreamWriter (new FileOutputStream (chemin)));
			
			Vector<SourcePanel> sources = f.getSources();
			
			int i = 1;
			for (SourcePanel p : sources) {
				String id = "S"+i;
				writer.println(id+"description="+p.champsP.nomChamp.getText());
				writer.println(id+"noyauInf="+p.champsP.noyauInf.getText());
				writer.println(id+"noyauSup="+p.champsP.noyauSup.getText());
				writer.println(id+"checked="+p.champsP.precisionCB.isSelected());
				writer.println(id+"supportInf="+p.champsP.supportInf.getText());
				writer.println(id+"supportSup="+p.champsP.supportSup.getText());
				writer.println(id+"precision="+p.incertitudeP.incertitudeSlider.getValue());
				i++;
			}

			writer.close();
		} catch (Exception e){
			System.out.println("Cannot save");
		}
	}
	
	public void charger(String chemin){
		Properties prop = new Properties(); 
		
		File file = new File(chemin);
		
		if (!file.exists()) {
			System.out.println("Cannot open file "+chemin);
			return;
		}
		
		try {
			FileInputStream in = new FileInputStream(chemin);
			prop.load(in);
			in.close(); 
		} catch (Exception e){
			e.printStackTrace();
		}
		
		f.tabbedPane.setVisible(false);
		
		int i = 1;
		int indice = f.tabbedPane.getTabCount();
		
		while ((prop.getProperty("S"+i+"precision"))!=null && !prop.getProperty("S"+i+"precision").equals("") ) {
			String id = "S"+i;
			f.nouvelleSource();
			SourcePanel source = ((OngletPanel)f.tabbedPane.getComponentAt(indice)).source;
			
			source.champsP.nomChamp.setText(prop.getProperty(id+"description"));
			source.champsP.noyauInf.setText(prop.getProperty(id+"noyauInf"));
			source.champsP.noyauSup.setText(prop.getProperty(id+"noyauSup"));
			source.champsP.supportInf.setText(prop.getProperty(id+"supportInf"));
			source.champsP.supportSup.setText(prop.getProperty(id+"supportSup"));
			
			
			
			if (!prop.getProperty(id+"checked").equals("true")) {
				source.champsP.precisionCB.setSelected(false);
				source.champsP.afficherSupport();
			}
			
			source.incertitudeP.incertitudeSlider.setValue(Integer.parseInt(prop.getProperty(id+"precision")));
			
			indice ++;
			i++;
			
		}
		if (f.tabbedPane.getTabCount() > 0) {
			f.tabbedPane.setVisible(true);
			f.tabbedPane.setSelectedIndex(0);
		}
		
	}

}
