package estimateur.gui.estimation;

import java.awt.BorderLayout;
import java.awt.HeadlessException;
import java.util.Vector;

import javax.swing.*;

public class ResultatFrame extends JFrame {
	
	private JLabel verdict;
	
	private Graphique graphe;

	public ResultatFrame(String verdict, Graphique graphe) throws HeadlessException {
		super();
		this.verdict = new JLabel(verdict);
		this.graphe = graphe;
		
		this.setSize(850, 578);
		this.setTitle("Estimation");
		this.setLocationRelativeTo(null);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setIconImage(estimateur.gui.Util.call.imageFromJar("img/logo.png"));
		
		JPanel mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());
		mainPanel.setBorder(BorderFactory.createEmptyBorder(7,7,7,7));
		
		this.verdict.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
		
		mainPanel.add(this.verdict,BorderLayout.NORTH);
		mainPanel.add(this.graphe,BorderLayout.CENTER);
		
		this.getContentPane().add(mainPanel);
		this.setVisible(true);
		
	}
	
	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel("com.pagosoft.plaf.PgsLookAndFeel");
		} catch(Exception e) {}
		
		JFrame f = new ResultatFrame("text...",new Graphique(null));		
	}
	
	

}
