package estimateur.gui.estimation;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.util.*;

import estimateur.gui.FenetrePrincipale;
import estimateur.gui.financement.*;

import estimateur.modele.*;
import estimateur.controleur.*;

import java.awt.event.*;

public class SelectionDialog extends JDialog {
	
	private FenetrePrincipale parente;
	
	private JTable table;
	
	private SourceTableModel stm;
	
	private JButton calculerB, annulerB;
	
	private Vector<SourcePanel> sources;
	
	public SelectionDialog(FenetrePrincipale parent, Vector<SourcePanel> sourcesV){
		super(parent,true);
		
		this.sources = sourcesV;
		
		this.parente = parent;
		this.setTitle("Source selection");
		this.setSize(340, 264);
		this.setLocationRelativeTo(null);
		
		JPanel mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());
		mainPanel.setBorder(BorderFactory.createEmptyBorder(15,7,7,7));
		
		JLabel infoTexte = new JLabel("<html>Please select the sources to consider " +
				"for the calculation. <br/><br/></html>");
		
		
		String[] columnsNames = {"Use?",
                "Name"};
		
		
		this.stm = new SourceTableModel(columnsNames,0);

		for (SourcePanel source : sourcesV) {
			Object[] data = {Boolean.TRUE, source.champsP.nomChamp.getText()};
			stm.addRow(data);
		}

		
		this.table = new JTable(stm);
		this.table.getColumnModel().getColumn(0).setMaxWidth(
				table.getColumnModel().getColumn(0).getPreferredWidth());
		
		this.calculerB = new JButton("Calculate");
		calculerB.addActionListener(new ActionCalculer());
		this.annulerB = new JButton("Cancel");
		annulerB.addActionListener(new ActionAnnuler());
		
		// Mise en page
		JPanel southP = new JPanel();
		southP.setBorder(BorderFactory.createEmptyBorder(12, 17, 5, 17));
		southP.setLayout(new BoxLayout(southP, BoxLayout.X_AXIS));
		southP.setAlignmentX(Component.CENTER_ALIGNMENT);
		southP.add(Box.createHorizontalGlue());
		southP.add(this.calculerB);
		southP.add(Box.createHorizontalGlue());
		southP.add(this.annulerB);
		southP.add(Box.createHorizontalGlue());
			    
		mainPanel.add(infoTexte,BorderLayout.NORTH);
		mainPanel.add(new JScrollPane(this.table),BorderLayout.CENTER);
		mainPanel.add(southP,BorderLayout.SOUTH);
		
		this.getContentPane().add(mainPanel);
		this.setVisible(true);
	}
	
	public void exit(){
		this.dispose();
	}
	
	private class ActionAnnuler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			exit();
	    }
	}
	
	private class ActionCalculer implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			Vector<Financement> financements = new Vector<Financement>();
			int nb = stm.getRowCount();
			for (int i = 0; i < nb; i++){
				if ((Boolean)stm.getValueAt(i, 0)) {
					//Cette source a été sélectionnée
					Financement f = sources.get(i).toFinancement();
					financements.add(f);
				}
			}
			//On a un créé un vecteur de Financement
			// Est-il vide ?
			if (financements.size() == 0){
				parente.afficherErreur("Please select at least one source!");
				return;
			}
			// Le vecteur de sources est envoyé au contrôleur
			
			// Plus besoin de la boîte de sélection
			exit();
			
			Analyseur.sources = financements;
			Analyseur.estimer();
	    }
	}

}
