package estimateur.gui.financement;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

/**
 * Ce panel est une sous-partie de SourcePanel. 
 * Il ne contient que les champs de description, de support 
 * et de noyau de la source de financement. 
 *
 */

public class ChampsPanel extends JPanel {
	
	public JTextField nomChamp;
	
	public JCheckBox precisionCB;
	
	private JPanel nord;
	
	private JPanel supportCachable;
	
	private JLabel precisionNoyau;
	
	public JTextField noyauInf;
	
	public JTextField noyauSup;
	
	public JTextField supportInf;
	
	public JTextField supportSup;
	

	
	public ChampsPanel() {
		super();
		
		//Etirement horizontal
		this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		
		//Initialisation des éléments graphiques
		this.nomChamp = new JTextField(12);
		nomChamp.setText("Description...");
		nomChamp.setMaximumSize(nomChamp.getPreferredSize());
		
		this.precisionCB = new JCheckBox();
		this.precisionCB.setSelected(true);
		
		this.precisionNoyau = new JLabel(" € exactly.                              ");
		
		this.noyauInf = new JTextField(7);
		noyauInf.setMaximumSize(noyauInf.getPreferredSize());
		noyauInf.setMinimumSize(noyauInf.getPreferredSize());
		this.noyauSup = new JTextField(7);
		noyauSup.setMaximumSize(noyauSup.getPreferredSize());
		noyauSup.setMinimumSize(noyauSup.getPreferredSize());
		
		//partie cachable
		this.supportCachable = new JPanel();
		this.supportInf = new JTextField(7);
		supportInf.setMaximumSize(supportInf.getPreferredSize());
		supportInf.setMinimumSize(supportInf.getPreferredSize());
		this.supportSup = new JTextField(7);
		supportSup.setMaximumSize(supportSup.getPreferredSize());
		supportSup.setMinimumSize(supportSup.getPreferredSize());
		
		//Listeners
		this.precisionCB.addActionListener(new precisionListener());
		
		// Sous JPanel : noms et checkbox de précision
		JPanel nordOuest = new JPanel();
		nordOuest.setLayout(new BoxLayout(nordOuest, BoxLayout.Y_AXIS));
		nordOuest.setAlignmentX(Component.LEFT_ALIGNMENT);

		
			//Nom
			JPanel nomPanel = new JPanel();
			nomPanel.setLayout(new BoxLayout(nomPanel, BoxLayout.X_AXIS));
			JLabel nomL = new JLabel("Name: ");
			nomL.setAlignmentX(Component.LEFT_ALIGNMENT);
			nomPanel.add(nomL);
			nomPanel.add(this.nomChamp);
			nomPanel.setAlignmentX(Component.LEFT_ALIGNMENT);
			
			// Checkbox de précision
			JPanel precisionPanel = new JPanel();
			precisionPanel.setLayout(new BoxLayout(precisionPanel, BoxLayout.X_AXIS));
			precisionPanel.add(this.precisionCB);
			precisionCB.setText("precisely known");
			precisionPanel.setAlignmentX(Component.LEFT_ALIGNMENT);
			
			nordOuest.add(nomPanel);
			nordOuest.add(Box.createRigidArea(new Dimension(20,20)));
			nordOuest.add(precisionPanel);
			nordOuest.setMinimumSize(nordOuest.getPreferredSize());
			
			
		// Sous JPanel : gère la définition du noyau et du support
		this.nord = new JPanel();
		nord.setLayout(new BoxLayout(nord, BoxLayout.Y_AXIS));
		
			// Noyau
			JPanel noyauPanel = new JPanel();
			noyauPanel.setLayout(new BoxLayout(noyauPanel, BoxLayout.X_AXIS));
			noyauPanel.add(new JLabel("between "));
			noyauPanel.setAlignmentX(Component.LEFT_ALIGNMENT);
			noyauPanel.add(this.noyauInf);
			noyauPanel.add(new JLabel(" € and "));
			noyauPanel.add(this.noyauSup);
			noyauPanel.add(this.precisionNoyau);
			noyauPanel.setMinimumSize(noyauPanel.getPreferredSize());
			noyauPanel.setMaximumSize(noyauPanel.getPreferredSize());
			
			//Support
			supportCachable.setLayout(new BoxLayout(supportCachable, BoxLayout.X_AXIS));
			supportCachable.add(new JLabel("between "));
			supportCachable.setAlignmentX(Component.LEFT_ALIGNMENT);
			supportCachable.add(this.supportInf);
			supportCachable.add(new JLabel(" € and "));
			supportCachable.add(this.supportSup);
			supportCachable.add(new JLabel(" € is also possible."));
			
		
		nord.add(noyauPanel);
		nord.add(Box.createRigidArea(new Dimension(18,18)));
		nord.add(supportCachable);
		
		
		this.add(nordOuest);
		nordOuest.setAlignmentY(Component.TOP_ALIGNMENT);
		nordOuest.setAlignmentX(Component.LEFT_ALIGNMENT);
		this.add(Box.createHorizontalStrut(40));
		this.add(nord);
		nord.setAlignmentY(Component.TOP_ALIGNMENT);
		
		supportCachable.setVisible(false);


	}
	
	public void cacherSupport() {
		supportCachable.setVisible(false);
		precisionNoyau.setText(" € exactly.                         ");
	}
	
	public void afficherSupport(){
		supportCachable.setVisible(true);
		precisionNoyau.setText(" € is the most plausible.     ");
	}
	
	public class precisionListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			if (precisionCB.isSelected()) { cacherSupport();} else {afficherSupport();}
			}
		}
	
	
	public static void main(String[] args) {
		
		try {
			UIManager.setLookAndFeel("com.pagosoft.plaf.PgsLookAndFeel");
		} catch(Exception e) {}
		
		ChampsPanel p = new ChampsPanel();
		JFrame f = new JFrame();
		f.setSize(650, 378);
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		
		f.getContentPane().add(p);
		f.setVisible(true);
		
	}
	
	

}
