package estimateur.gui.financement;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import estimateur.gui.Util;
/**
 * Ce panel est une sous-partie de SourcePanel. 
 * Il ne contient que le réglage de l'incertitude.  
 *
 */

public class IncertitudePanel extends JPanel {
	
	public JSlider incertitudeSlider;
	
	private JLabel explication;
	
	private JLabel emotion;
	
	public IncertitudePanel() {
		super();
		
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		
		//Initialisation
		int certitudeInitiale = 3; //1 incertain - 5 est sûr
		this.explication = new JLabel();
		this.emotion = new JLabel();
		this.incertitudeSlider = new JSlider(JSlider.HORIZONTAL,1,5,certitudeInitiale);
		majDescription(certitudeInitiale);
		
		//Listener
		incertitudeSlider.addChangeListener(new SliderListener());

		
		//Disposition
		JPanel haut = new JPanel();
		haut.setLayout(new BoxLayout(haut, BoxLayout.X_AXIS));
		
		JLabel certitudeLabel = new JLabel("Reliability: ");
		certitudeLabel.setAlignmentX(LEFT_ALIGNMENT);
		haut.add(certitudeLabel);
		haut.add(this.incertitudeSlider);
		Dimension dim = incertitudeSlider.getMinimumSize();
		dim.setSize(90,dim.getHeight());
		incertitudeSlider.setMaximumSize(dim);
		
		JPanel bas = new JPanel();
		bas.setLayout(new BoxLayout(bas, BoxLayout.X_AXIS));
		
		//this.add(Box.createRigidArea(new Dimension(5,5)));
		bas.add(this.emotion);
		bas.add(Box.createRigidArea(new Dimension(4,4)));
		bas.add(this.explication);
		
		this.add(haut);
		this.add(Box.createVerticalStrut(7));
		this.add(bas);
		haut.setAlignmentX(Component.LEFT_ALIGNMENT);
		bas.setAlignmentX(Component.LEFT_ALIGNMENT);
		
		
	}
	
	/**
	 * En fonction de la valeur du slider, met à jour le descriptif.
	 * @param i niveau de certitude (1 incertain - 5 sûr)
	 */
	public void majDescription(int i) {
		String aAfficher = "";
		switch (i) {
			case 1 : aAfficher = "<html><i> There are almost no chance to get this funding. </i></html>"; break;
			case 2 : aAfficher = "<html><i> This funding is unlikely to be granted. </i></html>"; break;
			case 3 : aAfficher = "<html><i> This funding is uncertain. </i></html>"; break;
			case 4 : aAfficher = "<html><i> This funding is likely to be granted. </i></html>"; break;
			case 5 : aAfficher = "<html><i> This funding is 100% sure. </i></html>"; break;
			default: aAfficher = "<html><i> error "; break;		
		}
		this.explication.setText(aAfficher);	
		this.emotion.setIcon(new ImageIcon(
				Util.call.imageFromJar("img/incertitude/"+i+".gif")));
	}
	
	public static void main(String[] args) {
		
		JPanel p = new IncertitudePanel();
		JFrame f = new JFrame();
		f.setSize(650, 378);
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		f.getContentPane().add(p);
		f.setVisible(true);
		
	}
	
	
	class SliderListener implements ChangeListener {
		
	    public void stateChanged(ChangeEvent e) {    
	    	//Le curseur a été déplacé, on met à jour
	    	//le texte descriptif
	    	JSlider s = incertitudeSlider;
	    	majDescription(s.getValue());
	    }
	}

	

}
