package estimateur.modele;

import java.util.Collections;
import java.util.Vector;

public class Test {

	private static void afficherUnion(Vector<Intervalle> union) {
		for (int i=0; i<union.size()-1; i++) {
			System.out.print(union.get(i) + " U ");
		}
		System.out.println(union.lastElement());
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			Vector<Financement> financementsDeTest = new Vector<Financement>();
			//financementsDeTest.add(new Financement(2d, 4d, 2d, 3d, Incertitude.SUR, "f1"));
			//financementsDeTest.add(new Financement(-30d, -10d, -15d, -10d, Incertitude.RAISONNABLE, "f2"));
			//financementsDeTest.add(new Financement(0d, 10d, 6d, 8d, Incertitude.SUR, "f3"));
			/* 
			financementsDeTest.add(new Financement(60d, 80d, 62d, 70d, Incertitude.INCERTAIN, "f3"));
			financementsDeTest.add(new Financement(50d, 90d, 57d, 63d, Incertitude.PLUTOT_INCERTAIN, "f4"));
			financementsDeTest.add(new Financement(90d, 110d, 90d, 110d, Incertitude.TRES_INCERTAIN, "f5"));
			*/
			
			financementsDeTest.add(new Financement(100d, 100d, 100d, 100d, Incertitude.SUR, "A"));
			//financementsDeTest.add(new Financement(2d, 4d, 2d, 3d, Incertitude.SUR, "B"));
			financementsDeTest.add(new Financement(100d, 110d, 100d, 110d, Incertitude.RAISONNABLE, "C"));
			//financementsDeTest.add(new Financement(2d, 4d, 2d, 3d, Incertitude.SUR, "D"));
			
			System.out.print("Support de A: ");
			afficherUnion(financementsDeTest.elementAt(0).getAlphaCoupe(0d));
			System.out.print("Noyau de A: ");
			afficherUnion(financementsDeTest.elementAt(0).getAlphaCoupe(1d));
			System.out.println();
			
			System.out.print("Support de C: ");
			afficherUnion(financementsDeTest.elementAt(1).getAlphaCoupe(0d));
			System.out.print("Noyau de C: ");
			afficherUnion(financementsDeTest.elementAt(1).getAlphaCoupe(1d));
			System.out.println();

			Somme sommeDeTest = new Somme(financementsDeTest);
			
			//System.out.println("Support :");
			//afficherUnion(sommeDeTest.getAlphaCoupe(0d));
			
			Double alpha = 0d;
			while (alpha.compareTo(1d)<=0) { //alpha <= 1d
				Vector<Intervalle> coupe = sommeDeTest.getAlphaCoupe(alpha);
				if (coupe != null) {
					System.out.print("alpha="+alpha.floatValue()+"  coupe: ");
					afficherUnion(coupe);
				}
				alpha += 0.1d;
			}
			
			System.out.println( sommeDeTest.estimer(false) );
			
			//System.out.println("Noyau :");
			//afficherUnion(sommeDeTest.getAlphaCoupe(1d));
			
			//Financement test = new Financement(50d, 65d, 60d, 65d, Incertitude.RAISONNABLE, "f2");
			//afficherUnion(test.getAlphaCoupe(0d));
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
